import '../api/api.dart';
import '../model/release_data.dart';
import '../model/bundle_data.dart';

class LabelsService {
  static BundleData _cachedBundleData;

  static Future<ReleaseData> getLabels(
      String sdkToken,
      String distributionId,
      String currentLocale,
      String appInstallationId,
      String sdkBuildNumber,
      String appBuildNumber,
      {String deviceLocale,
      bool preRelease,
      int releaseVersion}) async {
    var bundleInfo = await Api.getBundleInfo(sdkToken, distributionId,
        currentLocale, appInstallationId, sdkBuildNumber, appBuildNumber,
        deviceLocale: deviceLocale,
        preRelease: preRelease,
        releaseVersion: releaseVersion);

    var isUpdateRequired = _cachedBundleData == null ||
        releaseVersion == null ||
        releaseVersion < bundleInfo.version;
    if (isUpdateRequired) {
      _cachedBundleData = await Api.getBundleData(bundleInfo.file);
    }

    return ReleaseData(
        version: bundleInfo.version, data: _cachedBundleData.data);
  }
}
